Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/molecules.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -3696,128 +4555,128 @@
 void molecule::SPFragmentGenerator(ofstream *out, struct UniqueFragments *FragmentSearch, int RootDistance, bond **BondsSet, int SetDimension, int SubOrder)
 {
-	atom *OtherWalker = NULL;
-	int verbosity = 0; //FragmentSearch->ANOVAOrder-SubOrder;
-	int NumCombinations;
-	bool bit;
-	int bits, TouchedIndex, SubSetDimension, SP, Added;
-	int Removal;
-	int SpaceLeft;
-	int *TouchedList = (int *) Malloc(sizeof(int)*(SubOrder+1), "molecule::SPFragmentGenerator: *TouchedList");
-	bond *Binder = NULL;
-	bond **BondsList = NULL;
-	KeySetTestPair TestKeySetInsert;
-
-	NumCombinations = 1 << SetDimension;
-
-	// Hier muessen von 1 bis NumberOfBondsPerAtom[Walker->nr] alle Kombinationen
-	// von Endstuecken (aus den Bonds) hinzugefï¿œï¿œgt werden und fï¿œï¿œr verbleibende ANOVAOrder
-	// rekursiv GraphCrawler in der nï¿œï¿œchsten Ebene aufgerufen werden
-
-	*out << Verbose(1+verbosity) << "Begin of SPFragmentGenerator." << endl;
-	*out << Verbose(1+verbosity) << "We are " << RootDistance << " away from Root, which is " << *FragmentSearch->Root << ", SubOrder is " << SubOrder << ", SetDimension is " << SetDimension << " and this means " <<	NumCombinations-1 << " combination(s)." << endl;
-
-	// initialised touched list (stores added atoms on this level)
-	*out << Verbose(1+verbosity) << "Clearing touched list." << endl;
-	for (TouchedIndex=SubOrder+1;TouchedIndex--;)	// empty touched list
-		TouchedList[TouchedIndex] = -1;
-	TouchedIndex = 0;
-
-	// create every possible combination of the endpieces
-	*out << Verbose(1+verbosity) << "Going through all combinations of the power set." << endl;
-	for (int i=1;i<NumCombinations;i++) {	// sweep through all power set combinations (skip empty set!)
-		// count the set bit of i
-		bits = 0;
-		for (int j=SetDimension;j--;)
-			bits += (i & (1 << j)) >> j;
-
-		*out << Verbose(1+verbosity) << "Current set is " << Binary(i | (1 << SetDimension)) << ", number of bits is " << bits << "." << endl;
-		if (bits <= SubOrder) { // if not greater than additional atoms allowed on stack, continue
-			// --1-- add this set of the power set of bond partners to the snake stack
-			Added = 0;
-			for (int j=0;j<SetDimension;j++) {	// pull out every bit by shifting
-				bit = ((i & (1 << j)) != 0);	// mask the bit for the j-th bond
-				if (bit) {	// if bit is set, we add this bond partner
-					OtherWalker = BondsSet[j]->rightatom;	// rightatom is always the one more distant, i.e. the one to add
-					//*out << Verbose(1+verbosity) << "Current Bond is " << ListOfBondsPerAtom[Walker->nr][i] << ", checking on " << *OtherWalker << "." << endl;
-					*out << Verbose(2+verbosity) << "Adding " << *OtherWalker << " with nr " << OtherWalker->nr << "." << endl;
-					TestKeySetInsert = FragmentSearch->FragmentSet->insert(OtherWalker->nr);
-					if (TestKeySetInsert.second) {
-						TouchedList[TouchedIndex++] = OtherWalker->nr;	// note as added
-						Added++;
-					} else {
-						*out << Verbose(2+verbosity) << "This was item was already present in the keyset." << endl;
-					}
-						//FragmentSearch->UsedList[OtherWalker->nr][i] = true;
-					//}
-				} else {
-					*out << Verbose(2+verbosity) << "Not adding." << endl;
-				}
-			}
-
-			SpaceLeft = SubOrder - Added ;// SubOrder - bits; // due to item's maybe being already present, this does not work anymore
-			if (SpaceLeft > 0) {
-				*out << Verbose(1+verbosity) << "There's still some space left on stack: " << SpaceLeft << "." << endl;
-				if (SubOrder > 1) {		// Due to Added above we have to check extra whether we're not already reaching beyond the desired Order
-					// --2-- look at all added end pieces of this combination, construct bond subsets and sweep through a power set of these by recursion
-					SP = RootDistance+1;	// this is the next level
-					// first count the members in the subset
-					SubSetDimension = 0;
-					Binder = FragmentSearch->BondsPerSPList[2*SP];		// start node for this level
-					while (Binder->next != FragmentSearch->BondsPerSPList[2*SP+1]) {		// compare to end node of this level
-						Binder = Binder->next;
-						for (int k=TouchedIndex;k--;) {
-							if (Binder->Contains(TouchedList[k]))	 // if we added this very endpiece
-								SubSetDimension++;
-						}
-					}
-					// then allocate and fill the list
-					BondsList = (bond **) Malloc(sizeof(bond *)*SubSetDimension, "molecule::SPFragmentGenerator: **BondsList");
-					SubSetDimension = 0;
-					Binder = FragmentSearch->BondsPerSPList[2*SP];
-					while (Binder->next != FragmentSearch->BondsPerSPList[2*SP+1]) {
-						Binder = Binder->next;
-						for (int k=0;k<TouchedIndex;k++) {
-							if (Binder->leftatom->nr == TouchedList[k])	 // leftatom is always the close one
-								BondsList[SubSetDimension++] = Binder;
-						}
-					}
-					*out << Verbose(2+verbosity) << "Calling subset generator " << SP << " away from root " << *FragmentSearch->Root << " with sub set dimension " << SubSetDimension << "." << endl;
-					SPFragmentGenerator(out, FragmentSearch, SP, BondsList, SubSetDimension, SubOrder-bits);
-					Free((void **)&BondsList, "molecule::SPFragmentGenerator: **BondsList");
-				}
-			} else {
-				// --2-- otherwise store the complete fragment
-				*out << Verbose(1+verbosity) << "Enough items on stack for a fragment!" << endl;
-				// store fragment as a KeySet
-				*out << Verbose(2) << "Found a new fragment[" << FragmentSearch->FragmentCounter << "], local nr.s are: ";
-				for(KeySet::iterator runner = FragmentSearch->FragmentSet->begin(); runner != FragmentSearch->FragmentSet->end(); runner++)
-					*out << (*runner) << " ";
-				*out << endl;
-				//if (!CheckForConnectedSubgraph(out, FragmentSearch->FragmentSet))
-					//*out << Verbose(0) << "ERROR: The found fragment is not a connected subgraph!" << endl;
-				InsertFragmentIntoGraph(out, FragmentSearch);
-				//Removal = LookForRemovalCandidate(out, FragmentSearch->FragmentSet, FragmentSearch->ShortestPathList);
-				//Removal = StoreFragmentFromStack(out, FragmentSearch->Root, FragmentSearch->Leaflet, FragmentSearch->FragmentStack, FragmentSearch->ShortestPathList, &FragmentSearch->FragmentCounter, FragmentSearch->configuration);
-			}
-
-			// --3-- remove all added items in this level from snake stack
-			*out << Verbose(1+verbosity) << "Removing all items that were added on this SP level " << RootDistance << "." << endl;
-			for(int j=0;j<TouchedIndex;j++) {
-				Removal = TouchedList[j];
-				*out << Verbose(2+verbosity) << "Removing item nr. " << Removal << " from snake stack." << endl;
-				FragmentSearch->FragmentSet->erase(Removal);
-				TouchedList[j] = -1;
-			}
-			*out << Verbose(2) << "Remaining local nr.s on snake stack are: ";
-			for(KeySet::iterator runner = FragmentSearch->FragmentSet->begin(); runner != FragmentSearch->FragmentSet->end(); runner++)
-				*out << (*runner) << " ";
-			*out << endl;
-			TouchedIndex = 0; // set Index to 0 for list of atoms added on this level
-		} else {
-			*out << Verbose(2+verbosity) << "More atoms to add for this set (" << bits << ") than space left on stack " << SubOrder << ", skipping this set." << endl;
-		}
-	}
-	Free((void **)&TouchedList, "molecule::SPFragmentGenerator: *TouchedList");
-	*out << Verbose(1+verbosity) << "End of SPFragmentGenerator, " << RootDistance << " away from Root " << *FragmentSearch->Root << " and SubOrder is " << SubOrder << "." << endl;
+  atom *OtherWalker = NULL;
+  int verbosity = 0; //FragmentSearch->ANOVAOrder-SubOrder;
+  int NumCombinations;
+  bool bit;
+  int bits, TouchedIndex, SubSetDimension, SP, Added;
+  int Removal;
+  int SpaceLeft;
+  int *TouchedList = (int *) Malloc(sizeof(int)*(SubOrder+1), "molecule::SPFragmentGenerator: *TouchedList");
+  bond *Binder = NULL;
+  bond **BondsList = NULL;
+  KeySetTestPair TestKeySetInsert;
+
+  NumCombinations = 1 << SetDimension;
+
+  // Hier muessen von 1 bis NumberOfBondsPerAtom[Walker->nr] alle Kombinationen
+  // von Endstuecken (aus den Bonds) hinzugefï¿œï¿œgt werden und fï¿œï¿œr verbleibende ANOVAOrder
+  // rekursiv GraphCrawler in der nï¿œï¿œchsten Ebene aufgerufen werden
+
+  *out << Verbose(1+verbosity) << "Begin of SPFragmentGenerator." << endl;
+  *out << Verbose(1+verbosity) << "We are " << RootDistance << " away from Root, which is " << *FragmentSearch->Root << ", SubOrder is " << SubOrder << ", SetDimension is " << SetDimension << " and this means " <<  NumCombinations-1 << " combination(s)." << endl;
+
+  // initialised touched list (stores added atoms on this level)
+  *out << Verbose(1+verbosity) << "Clearing touched list." << endl;
+  for (TouchedIndex=SubOrder+1;TouchedIndex--;)  // empty touched list
+    TouchedList[TouchedIndex] = -1;
+  TouchedIndex = 0;
+
+  // create every possible combination of the endpieces
+  *out << Verbose(1+verbosity) << "Going through all combinations of the power set." << endl;
+  for (int i=1;i<NumCombinations;i++) {  // sweep through all power set combinations (skip empty set!)
+    // count the set bit of i
+    bits = 0;
+    for (int j=SetDimension;j--;)
+      bits += (i & (1 << j)) >> j;
+
+    *out << Verbose(1+verbosity) << "Current set is " << Binary(i | (1 << SetDimension)) << ", number of bits is " << bits << "." << endl;
+    if (bits <= SubOrder) { // if not greater than additional atoms allowed on stack, continue
+      // --1-- add this set of the power set of bond partners to the snake stack
+      Added = 0;
+      for (int j=0;j<SetDimension;j++) {  // pull out every bit by shifting
+        bit = ((i & (1 << j)) != 0);  // mask the bit for the j-th bond
+        if (bit) {  // if bit is set, we add this bond partner
+          OtherWalker = BondsSet[j]->rightatom;  // rightatom is always the one more distant, i.e. the one to add
+          //*out << Verbose(1+verbosity) << "Current Bond is " << ListOfBondsPerAtom[Walker->nr][i] << ", checking on " << *OtherWalker << "." << endl;
+          *out << Verbose(2+verbosity) << "Adding " << *OtherWalker << " with nr " << OtherWalker->nr << "." << endl;
+          TestKeySetInsert = FragmentSearch->FragmentSet->insert(OtherWalker->nr);
+          if (TestKeySetInsert.second) {
+            TouchedList[TouchedIndex++] = OtherWalker->nr;  // note as added
+            Added++;
+          } else {
+            *out << Verbose(2+verbosity) << "This was item was already present in the keyset." << endl;
+          }
+            //FragmentSearch->UsedList[OtherWalker->nr][i] = true;
+          //}
+        } else {
+          *out << Verbose(2+verbosity) << "Not adding." << endl;
+        }
+      }
+
+      SpaceLeft = SubOrder - Added ;// SubOrder - bits; // due to item's maybe being already present, this does not work anymore
+      if (SpaceLeft > 0) {
+        *out << Verbose(1+verbosity) << "There's still some space left on stack: " << SpaceLeft << "." << endl;
+        if (SubOrder > 1) {    // Due to Added above we have to check extra whether we're not already reaching beyond the desired Order
+          // --2-- look at all added end pieces of this combination, construct bond subsets and sweep through a power set of these by recursion
+          SP = RootDistance+1;  // this is the next level
+          // first count the members in the subset
+          SubSetDimension = 0;
+          Binder = FragmentSearch->BondsPerSPList[2*SP];    // start node for this level
+          while (Binder->next != FragmentSearch->BondsPerSPList[2*SP+1]) {    // compare to end node of this level
+            Binder = Binder->next;
+            for (int k=TouchedIndex;k--;) {
+              if (Binder->Contains(TouchedList[k]))   // if we added this very endpiece
+                SubSetDimension++;
+            }
+          }
+          // then allocate and fill the list
+          BondsList = (bond **) Malloc(sizeof(bond *)*SubSetDimension, "molecule::SPFragmentGenerator: **BondsList");
+          SubSetDimension = 0;
+          Binder = FragmentSearch->BondsPerSPList[2*SP];
+          while (Binder->next != FragmentSearch->BondsPerSPList[2*SP+1]) {
+            Binder = Binder->next;
+            for (int k=0;k<TouchedIndex;k++) {
+              if (Binder->leftatom->nr == TouchedList[k])   // leftatom is always the close one
+                BondsList[SubSetDimension++] = Binder;
+            }
+          }
+          *out << Verbose(2+verbosity) << "Calling subset generator " << SP << " away from root " << *FragmentSearch->Root << " with sub set dimension " << SubSetDimension << "." << endl;
+          SPFragmentGenerator(out, FragmentSearch, SP, BondsList, SubSetDimension, SubOrder-bits);
+          Free((void **)&BondsList, "molecule::SPFragmentGenerator: **BondsList");
+        }
+      } else {
+        // --2-- otherwise store the complete fragment
+        *out << Verbose(1+verbosity) << "Enough items on stack for a fragment!" << endl;
+        // store fragment as a KeySet
+        *out << Verbose(2) << "Found a new fragment[" << FragmentSearch->FragmentCounter << "], local nr.s are: ";
+        for(KeySet::iterator runner = FragmentSearch->FragmentSet->begin(); runner != FragmentSearch->FragmentSet->end(); runner++)
+          *out << (*runner) << " ";
+        *out << endl;
+        //if (!CheckForConnectedSubgraph(out, FragmentSearch->FragmentSet))
+          //*out << Verbose(0) << "ERROR: The found fragment is not a connected subgraph!" << endl;
+        InsertFragmentIntoGraph(out, FragmentSearch);
+        //Removal = LookForRemovalCandidate(out, FragmentSearch->FragmentSet, FragmentSearch->ShortestPathList);
+        //Removal = StoreFragmentFromStack(out, FragmentSearch->Root, FragmentSearch->Leaflet, FragmentSearch->FragmentStack, FragmentSearch->ShortestPathList, &FragmentSearch->FragmentCounter, FragmentSearch->configuration);
+      }
+
+      // --3-- remove all added items in this level from snake stack
+      *out << Verbose(1+verbosity) << "Removing all items that were added on this SP level " << RootDistance << "." << endl;
+      for(int j=0;j<TouchedIndex;j++) {
+        Removal = TouchedList[j];
+        *out << Verbose(2+verbosity) << "Removing item nr. " << Removal << " from snake stack." << endl;
+        FragmentSearch->FragmentSet->erase(Removal);
+        TouchedList[j] = -1;
+      }
+      *out << Verbose(2) << "Remaining local nr.s on snake stack are: ";
+      for(KeySet::iterator runner = FragmentSearch->FragmentSet->begin(); runner != FragmentSearch->FragmentSet->end(); runner++)
+        *out << (*runner) << " ";
+      *out << endl;
+      TouchedIndex = 0; // set Index to 0 for list of atoms added on this level
+    } else {
+      *out << Verbose(2+verbosity) << "More atoms to add for this set (" << bits << ") than space left on stack " << SubOrder << ", skipping this set." << endl;
+    }
+  }
+  Free((void **)&TouchedList, "molecule::SPFragmentGenerator: *TouchedList");
+  *out << Verbose(1+verbosity) << "End of SPFragmentGenerator, " << RootDistance << " away from Root " << *FragmentSearch->Root << " and SubOrder is " << SubOrder << "." << endl;
 };
 
@@ -3830,44 +4689,44 @@
 bool molecule::CheckForConnectedSubgraph(ofstream *out, KeySet *Fragment)
 {
-	atom *Walker = NULL, *Walker2 = NULL;
-	bool BondStatus = false;
-	int size;
-
-	*out << Verbose(1) << "Begin of CheckForConnectedSubgraph" << endl;
-	*out << Verbose(2) << "Disconnected atom: ";
-
-	// count number of atoms in graph
-	size = 0;
-	for(KeySet::iterator runner = Fragment->begin(); runner != Fragment->end(); runner++)
-		size++;
-	if (size > 1)
-		for(KeySet::iterator runner = Fragment->begin(); runner != Fragment->end(); runner++) {
-			Walker = FindAtom(*runner);
-			BondStatus = false;
-			for(KeySet::iterator runners = Fragment->begin(); runners != Fragment->end(); runners++) {
-				Walker2 = FindAtom(*runners);
-				for (int i=0;i<NumberOfBondsPerAtom[Walker->nr]; i++) {
-					if (ListOfBondsPerAtom[Walker->nr][i]->GetOtherAtom(Walker) == Walker2) {
-						BondStatus = true;
-						break;
-					}
-					if (BondStatus)
-						break;
-				}
-			}
-			if (!BondStatus) {
-				*out << (*Walker) << endl;
-				return false;
-			}
-		}
-	else {
-		*out << "none." << endl;
-		return true;
-	}
-	*out << "none." << endl;
-
-	*out << Verbose(1) << "End of CheckForConnectedSubgraph" << endl;
-
-	return true;
+  atom *Walker = NULL, *Walker2 = NULL;
+  bool BondStatus = false;
+  int size;
+
+  *out << Verbose(1) << "Begin of CheckForConnectedSubgraph" << endl;
+  *out << Verbose(2) << "Disconnected atom: ";
+
+  // count number of atoms in graph
+  size = 0;
+  for(KeySet::iterator runner = Fragment->begin(); runner != Fragment->end(); runner++)
+    size++;
+  if (size > 1)
+    for(KeySet::iterator runner = Fragment->begin(); runner != Fragment->end(); runner++) {
+      Walker = FindAtom(*runner);
+      BondStatus = false;
+      for(KeySet::iterator runners = Fragment->begin(); runners != Fragment->end(); runners++) {
+        Walker2 = FindAtom(*runners);
+        for (int i=0;i<NumberOfBondsPerAtom[Walker->nr]; i++) {
+          if (ListOfBondsPerAtom[Walker->nr][i]->GetOtherAtom(Walker) == Walker2) {
+            BondStatus = true;
+            break;
+          }
+          if (BondStatus)
+            break;
+        }
+      }
+      if (!BondStatus) {
+        *out << (*Walker) << endl;
+        return false;
+      }
+    }
+  else {
+    *out << "none." << endl;
+    return true;
+  }
+  *out << "none." << endl;
+
+  *out << Verbose(1) << "End of CheckForConnectedSubgraph" << endl;
+
+  return true;
 }
 
